# area of a circle radii = 1.0
#

from random import random
from math import *

R = 1.0
S_ideal = pi*R**2

n = 3
total = n**2

# regular grid
#
d = 2*R/n
Rs = -R+d/2

inside = 0

Xsav = []
Ysav = []

for i in range(n):
    y = Rs+i*d
    for j in range(n):
        x = Rs+j*d
            #a = sqrt(x**2+y**2)
        a = x**2+y**2
        if a<=R**2:
            inside +=1

p1 = inside/total
S_eval1  = (2*R)**2 *p1

# Monte-Carlo
#
inside = 0
for k in range(total):
    x = random()
    y = random()
    a = x**2+y**2
    if a<=R**2:
        inside +=1
p2 = inside/total
S_eval2  = (2*R)**2 *p2

print("n =", n)
print("S precise =", S_ideal)
print("S regular =", S_eval1)
print("S monteca =", S_eval2)
print("error-1 ={} %".format( abs(S_ideal-S_eval1)/S_ideal*100) )
print("error-2 ={} %".format( abs(S_ideal-S_eval2)/S_ideal*100) )

##== run-1 ==
##n = 2
##S precise = 3.141592653589793
##S regular = 4.0
##S monteca = 3.0
##error-1 =27.32395447351627 %
##error-2 =4.507034144862795 %

##== run-2 ==
##n = 3
##S precise = 3.141592653589793
##S regular = 4.0
##S monteca = 3.111111111111111
##error-1 =27.32395447351627 %
##error-2 =0.9702576317095634 %

