# area of a circle radii = 1.0
#

from random import random
from math import *

R = 1.0
S_ideal = pi*R**2

n = 30
total = n**2

# regular grid
#
d = 2*R/n
Rs = -R+d/2

X1in = []
Y1in = []
X1out= []
Y1out= []

inside = 0
for i in range(n):
    y = Rs+i*d
    for j in range(n):
        x = Rs+j*d
            #a = sqrt(x**2+y**2)
        a = x**2+y**2
        if a<=R**2:
            inside +=1
            X1in.append(x)
            Y1in.append(y)
        else:
            X1out.append(x)
            Y1out.append(y)

p1 = inside/total
S_eval1  = (2*R)**2 *p1

# Monte-Carlo
#
X2in = []
Y2in = []
X2out= []
Y2out= []

inside = 0
for k in range(total):
    x = (2*random()-1)*R
    y = (2*random()-1)*R
    a = x**2+y**2
    if a<=R**2:
        inside +=1
        X2in.append(x)
        Y2in.append(y)
    else:
        X2out.append(x)
        Y2out.append(y)
    
p2 = inside/total
S_eval2  = (2*R)**2 *p2

print("n =", n)
print("S precise =", S_ideal)
print("S regular =", S_eval1)
print("S monteca =", S_eval2)
print("error-1 ={} %".format( abs(S_ideal-S_eval1)/S_ideal*100) )
print("error-2 ={} %".format( abs(S_ideal-S_eval2)/S_ideal*100) )

import matplotlib.pyplot as PLT

PLT.figure(figsize=(8,8)) #, layout="tight")
PLT.scatter(X1in, Y1in, label="regular inside",     marker=".", color = "blue")
PLT.scatter(X1out,Y1out,label="regular outside",    marker="x", color = "#ffc0c0")
PLT.legend()
PLT.show()

PLT.figure(figsize=(8,8)) #, layout="tight")
PLT.scatter(X1in, Y1in, label="regular inside",     marker=".", color = "blue")
PLT.scatter(X1out,Y1out,label="regular outside",    marker="x", color = "#ffc0c0")
PLT.scatter(X2in, Y2in, label="Monte-Carlo inside", marker=".", color = "green")
PLT.scatter(X2out,Y2out,label="Monte-Carlo outside",marker="x", color = "#c0c0ff")
PLT.legend()
PLT.show()


##== run-1 ==
##n = 2
##S precise = 3.141592653589793
##S regular = 4.0
##S monteca = 3.0
##error-1 =27.32395447351627 %
##error-2 =4.507034144862795 %

##== run-2 ==
##n = 3
##S precise = 3.141592653589793
##S regular = 4.0
##S monteca = 3.111111111111111
##error-1 =27.32395447351627 %
##error-2 =0.9702576317095634 %

##== run-3 ==
##n = 10
##S precise = 3.141592653589793
##S regular = 3.2
##S monteca = 3.0
##error-1 =1.8591635788130243 %
##error-2 =4.507034144862795 %
