# area of a circle radii = 1.0
#

from random import random
from math import *

R = 1.0
S_ideal = pi*R**2

n = 3
total = n**2

# regular grid
#
d = 2*R/n
Rs = -R+d/2

def Regular():
    global R,n,total,d,Rs
    R2=R**2
    inside = 0
    for i in range(n):
        y = Rs+i*d
        for j in range(n):
            x = Rs+j*d
                #a = sqrt(x**2+y**2)
            a = x**2+y**2
            if a<=R2:
                inside +=1

    p = inside/total
    S_eval  = (2*R)**2 *p
    return S_eval, p

# Monte-Carlo
#
def MonteCarlo():
    global R,total,d,Rs
    R2=R**2
    inside = 0
    for k in range(total):
        x = (2*random()-1)*R
        y = (2*random()-1)*R
        a = x**2+y**2
        if a<=R2:
            inside +=1
        
    p = inside/total
    S_eval  = (2*R)**2 *p
    return S_eval, p

#V1 = []
#V2 = []
print("Regular    MonteC    Error %")
for i in range(10):
    S_eval1, p1 = Regular()
    S_eval2, p2 = MonteCarlo()
        #V1.append(S_eval1)
        #V2.append(S_eval2)
    print("{:8g} {:8g}  {:8g}".format(S_eval1, S_eval2, abs(1-S_eval2/S_ideal)*100))

print("\nError to regular = {:8g}%".format(abs(1-S_eval1/S_ideal)*100) )
print("n =", n)

#== run-1 ==
##Regular    MonteC    Error %
##   3.144    3.136   0.17802
##   3.144   3.1592  0.560459
##   3.144   3.1176   0.76371
##   3.144   3.1536  0.382206
##   3.144     3.15  0.267614
##   3.144   3.1492  0.242149
##   3.144     3.15  0.267614
##   3.144   3.1596  0.573192
##   3.144   3.1348  0.216217
##   3.144   3.1396  0.0634281
##
##Error to regular = 0.0634281%
##n = 100

#== run-2 ==
##Regular    MonteC    Error %
##     3.2      3.4   8.22536
##     3.2     2.92   7.05351
##     3.2        3   4.50703
##     3.2     2.84   9.59999
##     3.2      3.4   8.22536
##     3.2     2.88   8.32675
##     3.2     3.36   6.95212
##     3.2     3.36   6.95212
##     3.2     3.08   1.96056
##     3.2     3.04   3.23379
##
##Error to regular =  3.23379%
##n = 10

#== run-3 ==
##Regular    MonteC    Error %
##       4  3.55556   13.1768
##       4  2.66667   15.1174
##       4  3.11111  0.970258
##       4  3.11111  0.970258
##       4  3.11111  0.970258
##       4  3.55556   13.1768
##       4  3.55556   13.1768
##       4  3.55556   13.1768
##       4  3.55556   13.1768
##       4  2.66667   15.1174
##
##Error to regular =  15.1174%
##n = 3
